//
//		Exemple d'utilisation des routines contenues
//		dans la ROSSETMOD.lib et la ROSSETGraph.lib
//
//		Copyright 1992 Antoine ROSSET
//
//

#include "HeadersROSSET"
#include "LoMem.h"

void 		TestCopyBits32x32( void);
unsigned 	RangedRdm(unsigned min, unsigned max);
void 		TestCopyBitM32();

#include "ROSSETGraph.h"
#include "QDOffScreen.h"

main()
{
GDHandle				theGD;
CGrafPtr				theCPort;

/* Initialisation de la toolbox */

InitGraf(&thePort);
InitFonts();
FlushEvents(everyEvent,0);
InitWindows();
TEInit();
InitMenus();
InitCursor();
MaxApplZone();


/* Est-ce que l'on peut utiliser ces routines avec le mode mmoire actuel? */

theGD = GetGDevice();

if( PixMap32Bit( (**theGD).gdPMap) == true)
{
	#define MMU32bit 0x0CB2

	if( *(Boolean*)(MMU32bit) == 0)
	{
		/*	Il faut switcher en mode 32 bits */
		/*	dans le control panel: memory */
		ExitToShell();
	}
}

/* Est-ce que la carte vido est en mode 8 bits, 256 couleurs? */

if( (**(**theGD).gdPMap).pixelSize != 8) ExitToShell();


/* Cration d'un port graphique total */

theCPort = ( CGrafPtr) NewPtr( sizeof( CGrafPort));
OpenCPort( theCPort);
SetPort( theCPort);


/* On le paint totalement en noir */

ForeColor( blackColor);
PaintRect( &screenBits.bounds);


TestCopyBits32x32();

TestCopyBitM32();


CloseCPort( theCPort);
PaintBehind((WindowPeek) FrontWindow(), GrayRgn);

FlushEvents( everyEvent, 0L);
}


/********************************/
/*		CopyBits32x32			*/
/********************************/

void TestCopyBits32x32()
{
Handle	theIcons[10];
int		i;
Rect	Destination;
Point	thePoint;

/* Chargement de 10 icl8 en Rsrc, 32x32 pixels */

for(i=0; i<10; i++)
{
	theIcons[i] = GetResource( 'icl8', 300 + i);
	if( theIcons[i] == 0L) Debugger();
	DetachResource( theIcons[i]);
}

/* On les affiches avec CopyBits32x32 */

HideCursor();

while( !Button())
{
	for(i=0; i<10; i++)
	{
		GetMouse( &thePoint);
		
		Destination.left = thePoint.h;
		Destination.top = thePoint.v;
		Destination.right = Destination.left + 32;
		Destination.bottom = Destination.top + 32;
		
		/*	Avant d'afficher le dessin, on vrifie que le carr de
			destination fait partie de l'cran! SINON plante!!!! */
		
		if( 	Destination.bottom < screenBits.bounds.bottom &&
				Destination.right < screenBits.bounds.right)
		{
			CopyBits32x32( *theIcons[i], &Destination);
		}
		
		/*	Un semblant de syncronisation vido... */
		/*	Pour voir la rapidit de la fonction, otez le Delay()! */
		Delay(1, 0L);
	}
}

Delay(20, 0L);

while( !Button())
{
	Destination.left = RangedRdm( 0, screenBits.bounds.right - 32);
	Destination.right = Destination.left + 32;
	Destination.top = RangedRdm( 0, screenBits.bounds.bottom - 32);
	Destination.bottom = Destination.top + 32;

	CopyBits32x32( *theIcons[RangedRdm(0,10)], &Destination);
}

ShowCursor();

for(i=0; i<10; i++) DisposHandle( theIcons[i]);
}


/********************************/
/*		CopyBitsM32				*/
/********************************/

void TestCopyBitM32()
{
PicHandle		thePict;
PixMapHandle	thePixMap;
int				i;
Rect			Destination;

thePict = GetPicture( 128);
if( ((*thePict)->picFrame.right - (*thePict)->picFrame.left) % 32 != 0)
	DebugStr("\pLa largeur DOIT etre un multiple de 32 !!!");
	
PicToPix( thePict, &thePixMap);

Delay( 60, 0L);

HideCursor();
while( !Button())
{
	Destination.left = RangedRdm( 0, screenBits.bounds.right - ((*thePict)->picFrame.right - (*thePict)->picFrame.left));
	Destination.right = Destination.left + ((*thePict)->picFrame.right - (*thePict)->picFrame.left);
	Destination.top = RangedRdm( 0, screenBits.bounds.bottom - ((*thePict)->picFrame.bottom - (*thePict)->picFrame.top));
	Destination.bottom = Destination.top + ((*thePict)->picFrame.bottom - (*thePict)->picFrame.top);

	CopyBitsM32( (*thePixMap)->baseAddr, &Destination);


	/* 	On aurait pu utiliser CopyBitsM4  la place de CopyBitsM32, en effet, CopyBitsM32
		est plus contraignante: un multiple de 32 en largeur, tandis que CopyBitsM4 permet
		un multiple de 4 seulement.
		
		"Plus une fonction est contraignante, plus elle est lente..."
		
		Comparez les deux, en faisant des mesures de ticks pour vous en rendre compte... */

	/*	CopyBitsM4( (*thePixMap)->baseAddr, &Destination);	*/
}

ReleaseResource( thePict);
ZapPixMap( thePixMap);
ShowCursor();
}

unsigned RangedRdm(unsigned min, unsigned max)
{
	unsigned 	qdRdm;
	long		range, t;

	qdRdm = Random();
	range = max - min;
	t = (qdRdm * range) / 65536;
	return( t+min);
}